import codecs
import string
import re
import unicodedata
import operator


## push cumulative
def pushcml():
  global n1, n2, n3, n4
  global t1, t2, t3, t4

  for n in n1:
    if (n in t1):
      t1[n] += min(n1[n], 199)
    else:
      t1[n] = min(n1[n], 199)
  for n in n2:
    if (n in t2):
      t2[n] += min(n2[n], 199)
    else:
      t2[n] = min(n2[n], 199)
  for n in n3:
    if (n in t3):
      t3[n] += min(n3[n], 199)
    else:
      t3[n] = min(n3[n], 199)
  for n in n4:
    if (n in t4):
      t4[n] += min(n4[n], 199)
    else:
      t4[n] = min(n4[n], 199)
  n1 = {}
  n2 = {}
  n3 = {}
  n4 = {}



## sort/filter dict
def srt(n, m):
  g = {}
  for w in n:
    if(n[w] > m * 100):
      g[w] = n[w]
  return sorted(g.items(), key=lambda t: -t[1])


## build ngram dict
def ps(s):

  global n1, n2, n3, n4

  w3 = w2 = w1 = None

  for w0 in s.rsplit(" "):

    if(w0 == re.sub("[^a-z]+", ' ', w0)
       and w0 != '' and not w0.startswith('xxxxx')):

      w0 = w0[0:15]

      if(w3 is not None):
        ww = w3 + ' ' + w2 + ' ' + w1 + ' '  + w0
        if (ww in n4):
          n4[ww] += 1
        else:
          n4[ww] = 101
      w3 = w2

      if(w2 is not None):
        ww = w2 + ' ' + w1 + ' '  + w0
        if (ww in n3):
          n3[ww] += 1
        else:
          n3[ww] = 101
      w2 = w1

      if(w1 is not None):
        ww = w1 + ' '  + w0
        if (ww in n2):
          n2[ww] += 1
        else:
          n2[ww] = 101
      w1 = w0

      if(len(w0) > 1):
        ww = w0
        if (ww in n1):
          n1[ww] += 1
        else:
          n1[ww] = 101



## globals
c = "sampletweets.txt"
t1 = {}
t2 = {}
t3 = {}
t4 = {}
n1 = {}
n2 = {}
n3 = {}
n4 = {}


## parse tweets
f = codecs.open(c, encoding='latin1')
cn = 0
lu = None
for line in f:
  v = line.rsplit("\t", 4)
  if(len(v) == 4 and len(v[0]) > 0):
    cn += 1
    if(cn % 10000 == 0):
      print(cn)

    u = v[0]
    if(lu != u):
      pushcml()
      lu = u

    s = v[2].lower().encode('ascii', 'ignore').decode('ascii', 'ignore')
    s = re.sub("(([\w-]+://?|www[.])[^\s()<>]+(?:\([\w\d]+\)|([^[:punct:]\s]|/)))", ' ', s)
    s = s.replace("'", '')
    s = s.replace("rt @", 'xxxxx')
    s = s.replace("@", 'xxxxx')
    s = re.sub("\W+", ' ', s)
    ps(s.strip())

f.close()
pushcml()


## output ngrams
q = open("1gram.txt", 'w')
for w in srt(t1, 20):
  q.write("%s\t%s\n" % w)
q.close()

q = open("2gram.txt", 'w')
for w in srt(t2, 10):
  q.write("%s\t%s\n" % w)
q.close()

q = open("3gram.txt", 'w')
for w in srt(t3, 5):
  q.write("%s\t%s\n" % w)
q.close()

q = open("4gram.txt", 'w')
for w in srt(t4, 3):
  q.write("%s\t%s\n" % w)
q.close()